import std.stdio;


import std.string;
import std.uri;
interface Web {
	// Output functions
	void setCookie(string name, string value);
	void redirect(string where);
	void output(string type, const(byte)[] data);

	// Input functions
	string requestMethod();
	string getVar(string name, string def = null); // gets GET and POST data
	string getCookie(string name, string def = null); // default is val to return if variable not present, if null, it throws an exception
	string remoteAddr();
	string userAgent();
	string pathInfo();
	string scriptName();

	// Convenience functions
	bool isLocalhost();
	bool isPost();
}
/*
	This pretends to be CGI even when it actually isn't.
*/

class CGI : Web {
  public:
	void setCookie(string name, string value) {
		if(!embedded) {
			writefln("Set-Cookie: %s=%s", name, value); 
		} else {
			// FIXME: should overwrite a cookie by the same name that is already queued
			headersToSend ~= format("Set-Cookie: %s=%s\n", name, value);
		}
	}

	void redirect(string where) {
		writefln("Location: %s\n\n", where); // FIXME when embedded
	}

	void output(string type, const(byte)[] data) {
		if(!embedded) {
//			fwrite(data.ptr, 1, data.length, stdout);
//			fclose(stdout);
			assert(0);
		} else {
			howToWrite(type, data, headersToSend);
			headersToSend = "";
		}
	}

	void output(string type, string data) {
		output(type, cast(const(byte)[]) data);
	}

	// Input functions
	string getVar(string name, string def = null){
		string* v = name in REQUEST;
		if(v is null)
			if(def !is null)
				return def;
			else
				throw new Exception("No value "~name~" in request.");
		else
			return *v;
	}

	string getCookie(string name, string def = null) {
		string* v = name in REQUEST; //COOKIES; // FIXME
		if(v is null)
			if(def !is null)
				return def;
			else
				throw new Exception("No value "~name~" in cookie.");
		else
			return *v;
	}

	string scriptName() {
		return SCRIPT_NAME;
	}
	string requestMethod() {
		return REQUEST_METHOD;
	}
	string remoteAddr() {
		return REMOTE_ADDR;
	}
	string userAgent(){
		return HTTP_USER_AGENT;
	}
	string pathInfo() {
		return PATH_INFO;
	}

	// Convenience functions
	bool isLocalhost() {
		return remoteAddr == "127.0.0.1";
	}
	bool isPost(){
		return requestMethod == "POST";
	}


	this () {

	}



	void initalize () {
		// fetch the vars from the environment and such
		embedded = false;

		// FIXME: needs implementation
	}

	private void initalize (string method, string name, string path, string query, string cookie, string contentType, const(byte[]) content, string addr, string agent, bool nowEmbedded = false) {

		embedded = nowEmbedded;

		REQUEST_METHOD = method;
		PATH_INFO = path;
		REMOTE_ADDR = addr;
		HTTP_USER_AGENT = agent;
		SCRIPT_NAME = name;
		// parse query and cookie and content here


		void lol(string q) {
			string[] parts = split(q, "&");
			foreach(part; parts) {
				int idx = indexOf(part, "=");
				if(idx == -1){
					REQUEST[part] = "";
					continue;
				}
				string name = part[0..idx];
				string val = part[idx+1..$];
				string a = replace(val, "+", " ");
				REQUEST[name] = decodeComponent(a);
				// FIXME: this might not work with check boxes or multiple select boxes
			}
		}

		lol(query);

		lol(cookie);

		if(content.length) {
			if(contentType != "application/x-www-form-urlencoded")
				throw new Exception("Not implemented");
			lol(cast(string) content);
		}
	}

  private:
	string REMOTE_ADDR;
	string REQUEST_METHOD;
	string HTTP_USER_AGENT;
	string PATH_INFO;
	string SCRIPT_NAME;
	string[string] COOKIES;
	string[string] REQUEST;

	bool embedded;

	string headersToSend;

	void delegate(string, const(byte[]), string) howToWrite;
}



CGI cgi;
static this(){
	cgi = new CGI;
}

//void prepareFromRealServer
//void prepareFromUser

void prepareFromEmbeddedServer (string method, string uri, string name, string pathinfo, string query, string userAgent, string cookie, string remote_addr, string contentType, const(byte)[] content, void delegate(string, const(byte[]), string) howToWrite) {
	bool embed = true;
/*
	string path;
	string query;

	int idx = find(uri, "?");
	if(idx == -1) {
		query = "";
		path = uri;
	} else {
		query = uri[idx+1..$];
		path = uri[0..idx];
	}
*/
	cgi.initalize(method, name, pathinfo, query, cookie, contentType, content, remote_addr, userAgent, embed);

	cgi.howToWrite = howToWrite;
}




/*
import std.date;
int now() {
	return getUTCtime();
}
*/
