#include"accesswindow.h"


AccessWindow::AccessWindow(QWidget* parent)
	:QMainWindow(parent) {

	currentItem = NULL;

	ui.setupUi(this);

	sti = new QSystemTrayIcon(QIcon("icon.png"));
	sti->show();

	connect(ui.listWidget, SIGNAL(itemDoubleClicked(QListWidgetItem*)), this, SLOT(toggleAttach(QListWidgetItem*)));
	connect(ui.listWidget, SIGNAL(currentItemChanged(QListWidgetItem*, QListWidgetItem*)),this, SLOT(selected(QListWidgetItem*)));

	connect(ui.action_Attach, SIGNAL(triggered()), this, SLOT(attachCurrent()));
	connect(ui.action_Detach, SIGNAL(triggered()), this, SLOT(detachCurrent()));
}

void AccessWindow::updateButtons() {
		ui.action_Attach->setEnabled(!(currentItem->attachedHere));
		ui.action_Detach->setEnabled((currentItem->attachedHere));
		ui.attachButton->setEnabled(!(currentItem->attachedHere));
		ui.detachButton->setEnabled(currentItem->attachedHere);	
}


void AccessWindow::selected(QListWidgetItem* i) {
	if(i != NULL) {
	printf("selected");
		currentItem = dynamic_cast<Item*>(i);

		updateButtons();	
	} else {
		ui.action_Attach->setEnabled(false);
		ui.action_Detach->setEnabled(false);
		ui.attachButton->setEnabled(false);
		ui.detachButton->setEnabled(false);
	}
}

void AccessWindow::requestAttach(QListWidgetItem* ci) {
	if(ci == NULL)
		return;
	
	Item* i = dynamic_cast<Item*>(ci);

	i->attachedHere = true;

	if(ci == currentItem)
		updateButtons();

	emit attachRequested(i->id);
}

void AccessWindow::requestDetach(QListWidgetItem* ci) {
	if(ci == NULL)
		return;

	Item* i = dynamic_cast<Item*>(ci);
	
	i->attachedHere = false;

	if(i == currentItem)
		updateButtons();
	
	emit detachRequested(i->id);
}

void AccessWindow::detachCurrent() {
	requestDetach(currentItem);
}

void AccessWindow::attachCurrent() {
	requestAttach(currentItem);
}

void AccessWindow::removeClient(int id) {
	Item* i = itemMap[id];
	itemMap.remove(id);

	ui.listWidget->removeItemWidget(i);
	delete i;
}

void AccessWindow::clientNameChange(int id, QString name) {
	Item* i = itemMap[id];
	if(!i) 	return;
	i->name = name;
	i->setText(name);
}


void AccessWindow::toggleAttach(QListWidgetItem* item) {
	// FIXME: hack
	if(currentItem == 0)
		return;
	if(currentItem->attachedHere)
		requestDetach(currentItem);//item->row());
	else
		requestAttach(currentItem);//item->row());
}

void AccessWindow::closeEvent(QCloseEvent* e) {
	e->accept();
	emit closing();
}

void AccessWindow::newClient(int id){

	Item* i = new Item;

	i->id = id;
	i->name = QString("%1").arg(id);
	i->setText(i->name);
	i->attachedHere = false;

	itemMap[id] = i;


	ui.listWidget->addItem(i);
}

