#ifndef ACCESSWINDOW_H
#define ACCESSWINDOW_H

#include"ui_accesswindow.h"

#include<QCloseEvent>
#include<QSystemTrayIcon>

struct Item : QListWidgetItem {
	int id;
	QString name;

	bool attachedHere;
};

class AccessWindow : public QMainWindow {
	Q_OBJECT
  public:
	AccessWindow(QWidget* parent = NULL);


  public slots:
  	void newClient(int id);

	void clientNameChange(int id, QString name);

	void removeClient(int id);


	void toggleAttach(QListWidgetItem*);

	void selected(QListWidgetItem*);
	void attachCurrent();
	void detachCurrent();

  signals:
  	void attachRequested(int);
  	void detachRequested(int);
	void closing();


  protected:
  	void closeEvent(QCloseEvent* e);

  private:

	void updateButtons();
	void requestAttach(QListWidgetItem*);
	void requestDetach(QListWidgetItem*);

  	Ui::MainWindow ui;
	QSystemTrayIcon* sti;

	QMap<int, Item*> itemMap;

	Item* currentItem;
};

#endif
