#include <QtNetwork>
#include<QTimer>

#include "client.h"

QByteArray& Client::read() {
	return readBuffer;
}

void Client::resetRead() {
	//readBuffer.where = 0;
	//readBuffer.len = 0;
	readBuffer.resize(0);
}

void Client::changeReadPosition(int a) {
	//readBuffer.where = a;
}


Client::Client()
{
	queue = false;
	timer = false;
	tcpSocket = new QTcpSocket(this);
	connect(tcpSocket, SIGNAL(readyRead()), this, SLOT(readlol()));
	connect(tcpSocket, SIGNAL(error(QAbstractSocket::SocketError)), this, SLOT(quit()));

	connectlol();
}

int totalRead = 0;
int totalWrite = 0;
int writePackets = 0;
int readPackets = 0;

void Client::write(byte* b, int s, int e) {
	if(queue) {
		queuedData.append(QByteArray((const char*)(b+s), e-s));
		queue = false;

		if(!timer) {
			timer = true;
			QTimer::singleShot(3000, this, SLOT(timerSlot()));
		}
	} else {

		clearQueue();

		totalWrite += (e-s);
		writePackets++;
		printf("writing data: %d bytes (total: %d over %d bunches)\n", e-s, totalWrite, writePackets);
	tcpSocket->write((const char*)(b+s), e-s);
	
	}
}

void Client::timerSlot() {
	timer = false;
	clearQueue();
}

void Client::clearQueue() {
	if(queuedData.length()) {
		totalWrite += queuedData.length();
		printf("Writing queued data, %d bytes\n", queuedData.length());
		tcpSocket->write(queuedData);
		queuedData.clear();
	}
}


void Client::queueNext() {
	queue = true;
}


void Client::quit() {
	exit(0);
}

void Client::connectlol() {
	tcpSocket->connectToHost("localhost", 8080);
}

void Client::readlol() {
	QByteArray lol = tcpSocket->readAll();
	readBuffer.append(lol);
		totalRead += lol.size();
		readPackets++;
		printf("reading data %d bytes (total: %d over %d bunches)\n", lol.size(), totalRead, readPackets);
	onDataReceived();
}

void Client::doAttach(int id) {
	attachClient(id);
}

void Client::doDetach(int id) {
	detachClient(id);
}
