#ifndef CLIENT_H
 #define CLIENT_H

 #include <QTcpSocket>

 class QTcpSocket;

typedef unsigned char byte;

 class Client : public QObject
 {
     Q_OBJECT
 public:
     Client();

     void write(byte* b, int s, int e);
     QByteArray& read();
     void resetRead();
     void changeReadPosition(int a);

     virtual void onDataReceived() = 0;
	virtual void attachClient(int) = 0;
	virtual void detachClient(int) = 0;


	void queueNext();


 signals:
	void newClientAvailable(int id);

 private slots:
     void connectlol();
     void readlol();
     void quit();

     void clearQueue();
     void timerSlot();


	void doAttach(int);
	void doDetach(int);

 private:
     QTcpSocket *tcpSocket;

     QByteArray readBuffer;

     QByteArray queuedData;

     bool timer;
     bool queue;
 };

 #endif
