#include"control.h"

#define cast_control(x) \
	 type == PushButton ? \
		qobject_cast<QPushButton*>(widget) \
	:type == RichTextEdit ? \
		qobject_cast<QTextEdit*>(widget) \
	:type == ListBox ? \
		qobject_cast<QListWidget*>(widget) \
	: 0


Control::Control(GeneratedConnection* c, int type, QWidget* parent, int i) {
	client = c;
	programedEdit = false;
	textChanged = false;
	first = true;
	id = i;
	QWidget* w = NULL;
	QWidget* p = parent;
	switch(type) {
	  case PushButton:
	  	w = new QPushButton(p);

		connect(w, SIGNAL(pressed()), this, SLOT(buttonPressed()));
	  break;
	  case RichTextEdit: {
	  	QTextEdit* lol = new QTextEdit(p);
		w = lol;

		connect(w, SIGNAL(textChanged()), this, SLOT(noteTextChanged()));
		connect(w, SIGNAL(cursorPositionChanged()), this, SLOT(noteCursorChanged()));

		//lol->setHtml("<b>lol</b> wtf");
		//lol->setReadOnly(true);
	 } break;
	  case ListBox:
		w = new QListWidget(p);
	  break;
	  case Label:
	  	w = new QLabel(p);
	  break;
	  case LineEdit: {
	  	QLineEdit* lol = new QLineEdit(p);
	  	w = lol;
		connect(lol, SIGNAL(textEdited(QString)), this, SLOT(noteTextEdited(QString)));
	//	connect(lol, SIGNAL(cursorPositionChanged()), this, SLOT(noteCursorChanged()));
		connect(lol, SIGNAL(returnPressed()), this, SLOT(buttonPressed()));
	  }
	}

	w->show();
	widget = w;
}

// void Control::noteSelectionChanged() { }
// void Control::noteScrollChanged() { }

void Control::noteCursorChanged() {
	return; // FIXME: this should report it to the manager

	QTextEdit* t;
	t = qobject_cast<QTextEdit*>(widget);
	if(!t) return;


	lastCursor = t->textCursor();
}

void Control::buttonPressed() {
	client->controlTriggered(id);
}
void Control::noteTextEdited(const QString& text) {
	client->queueNext();
	client->textChanged(id, text);
}
void Control::noteTextChanged() {
	if(programedEdit) {
		programedEdit = false;

	QTextEdit* t;
	t = qobject_cast<QTextEdit*>(widget);
	if(!t) return;


		lastText = t->toPlainText();
		return;
	}
/*
	if(first) {
		first = false;
		return;
	}
*/
	if(!textChanged) {
		textChanged = true;
		sendTextUpdate();
	}
}

void Control::sendTextUpdate() {
	textChanged = false;

	QTextEdit* t;
	t = qobject_cast<QTextEdit*>(widget);
	if(!t) return;


	// Here, we make an assumption: the changed text is most likely close to the cursor position.
	// This lets us try to do a quicker search through the text.
	// The function overall should be somewhere around O(n).
	QTextCursor c;
	c = t->textCursor();


	if(lastCursor.isNull()) {
		lastCursor = c;
		lastCursor.setPosition(0);
	}


	// All changes should be before or after the cursor or the anchor.
	/*
		We store the old text and the old cursor.

		Old text at old cursor somehow goes to new text at new cursor

		Changes can be:
			backspace
				to determine: new cursor position < old cursor position
			delete
				ncp = ocp, new length < old length
			typing
				ncp > ocp
			cut
				ncp < ocp
			paste
				ncp > ocp
			undo/redo
				?????

			programmed changes (from the netw0rk) - these needn't be sent back down the network

	*/

	QString txt = t->toPlainText();



	/////



// FIXME send *correct* differential updates for all situations
// FIXME: handle selections of text

	client->queueNext();

	if(c == lastCursor && lastText.length() > txt.length()) {
		// delete
		client->textRemoved(id, c.position(), 1);
	} else

	if(/*c > lastCursor && */txt.length() > lastText.length()) {
		// we're typing something

		client->textInserted(id, lastCursor.position(), QString(txt[c.position()-1]));
	} else

	if(c < lastCursor && txt.length() < lastText.length()) {
		// backspace

		client->textRemoved(id, lastCursor.position(), 1);
	} else {
		printf("FIXME:  brute forcing text change update\n");
		// We dunno; just brute force
		client->textChanged(id, txt);

	}



	/////

	lastText = txt;

	lastCursor = t->textCursor();
//	setTextCursor(c);
	
}




/*
	Optimizing frequent change widget updates

	You have two options: immediate and buffered

	Immediate tries to minimize the wait before sending it - very chatty on the network

	Buffered says you don't care about the immediate changes, so they can come in whenever
		The changes are however guaranteed to be there when you receive an event.

	(Events always happen immediately)


	Actions, pushbuttons, input events, repaint events, attach/detach commands - all sent immediately
	Everything else is sent after a time out, when it reaches 1k, or when an immediate is to be sent, whichever comes first






*/
