#ifndef CONTROL_H
#define CONTROL_H

#include<QtGui>

#include"window.h"

#include"gen.h"

class Control : QObject {
	Q_OBJECT
  public:
	Control(GeneratedConnection* c, int type, QWidget* parent, int i);

	bool programedEdit;

	int id;

	QWidget* widget;
	GeneratedConnection* client;

	bool textChanged;
	bool first;



  private:
  	QString lastText;
	QTextCursor lastCursor;

  public slots:
	void noteCursorChanged();
	void noteTextChanged();
	void sendTextUpdate();
	void buttonPressed();
	void noteTextEdited(const QString& text);



};



enum ControlTypes {
	PushButton,
	Label,
	RichTextEdit,
	TextEdit,
	LineEdit,
	HTMLViewer,
	CheckBox,
	RadioButton,
	DropDownList,
	ComboBox,
	SpinBox,
	ScrollBar,
	Slider,
	ProgressBar,
	ListBox,
	ToolButton,
	Group
};

#endif
