
#ifndef GEN_H
#define GEN_H
#include"num.h"

#include<QString>
#include<QByteArray>

#include"client.h"

class GeneratedConnection : public Client{
public:


virtual void setApplicationTitle (QString  title);
virtual void setApplicationIcon (int  imageId);
virtual void createMainWindow (int  wid);
virtual void setStatusBarText (int  wid, QString  text);
virtual void addMenu (int  wid, int  menuId);
virtual void addToolBar (int  wid, int  actionId);
virtual void createDialog (int  wid, int  modalTo);
virtual void createPopup (int  wid);
virtual void createFrame (int  wid, int  parent);
virtual void createPage (int  wid, int  parent);
virtual void createDataStore (int  id);
virtual void setDataStoreSize (int  id, int  size);
virtual void setData (int  id, int  position, QByteArray  data);
virtual void setCompressedData (int  id, int  position, QByteArray  compressedData);
virtual void destroyDataStore (int  id);
virtual void createImage (int  id);
virtual void setImageData (int  id, QByteArray  data);
virtual void setImageDataFromStore (int  id, int  dataId);
virtual void destroyImage (int  id);
virtual void executeDataStoreAsCommands (int  id);
virtual void createConsole (int  consoleId);
virtual void writeLines (int  consoleId, QString  text);
virtual void writeAt (int  consoleId, int  x, int  y, QString  text);
virtual void moveCursor (int  consoleId, int  x, int  y);
virtual void getLine (int  consoleId, QString  &  val);
virtual void setConsoleMode (int  id, int  mode);
virtual void setConsoleAttributes (int  id, int  attrs);
virtual void setConsoleTitle (int  id, QString  title);
virtual void clearScreen (int  consoleId);
virtual void createCanvas (int  id);
virtual void setWindowTitle (int  wid, QString  title);
virtual void setWindowIcon (int  wid, int  imageId);
virtual void closeWindow (int  wid);
virtual void hideWindow (int  id);
virtual void showWindow (int  id);
virtual void messageBox (QString  title, QString  message);
virtual void beep (int  frequency, int  duration);
virtual void bell ();
virtual void createAction (int  actionId);
virtual void setActionText (int  id, QString  text);
virtual void setActionIcon (int  id, int  imageId);
virtual void disableAction (int  id);
virtual void enableAction (int  id);
virtual void createMenu (int  menuId, QString  title);
virtual void addMenuItem (int  menuId, int  actionId);
virtual void addMenuSeparator (int  menuId);
virtual void destroyMenu (int  menuId);
virtual void createControl (int  id, int  type, int  parentWindowId);
virtual void setControlGeometry (int  id, int  x, int  y, int  w, int  h);
virtual void destroyControl (int  id);
virtual void disableControl (int  id);
virtual void enableControl (int  id);
virtual void showControl (int  id);
virtual void hideControl (int  id);
virtual void setControlText (int  id, QString  text);
virtual void appendControlText (int  id, QString  text);
virtual void setControlImage (int  id, int  imageId);
virtual void setControlImagePosition (int  id, int  position);
virtual void setControlValue (int  id, int  val);
virtual void setControlValue2 (int  id, int  val);
virtual void setControlUpperLimit (int  id, int  val);
virtual void setControlLowerLimit (int  id, int  val);
virtual void setTextControlBufferMode (int  id, int  mode);
virtual void createItem (int  id, int  parent);
virtual void setItemText (int  id, QString  text);
virtual void setItemIcon (int  id, int  imageId);
virtual void destroyItem (int  id);
virtual void addItemToControl (int  itemId, int  controlId);
virtual void removeItemFromControl (int  itemId, int  controlId);
virtual void connect (int  controlId, int  srcfunc, int  receiverControlId, int  dstfunc);
virtual void disconnect (int  controlId, int  srcfunc, int  receiverControlId, int  dstfunc);
virtual void newClient (int  id);
virtual void clientNameChanged (int  id, QString  name);
virtual void clientIconChanged (int  id, int  imageId);
virtual void clientAttachedElsewhere (int  id);
virtual void clientDetached (int  id);
virtual void clientTerminated (int  id);
virtual void clientZombied (int  id);
void attachClient (int  id);
void detachClient (int  id);
void setDisplayName (QString  name);
void displayCapabilitiesUpdate (int  flags);
void attached ();
void detached ();
void actionTriggered (int  actionId);
void itemSelected (int  itemId, int  controlId);
void itemDoubleClicked (int  itemId, int  controlId);
void windowCloseRequested (int  wid);
void stateChanged (int  controlId, int  state);
void controlTriggered (int  controlId);
void controlValueChanged (int  controlId, int  value);
void textChanged (int  controlId, QString  newText);
void textInserted (int  controlId, int  pos, QString  text);
void textRemoved (int  controlId, int  start, int  end);
void cursorMoved (int  controlId, int  pos);
void scrollPositionChanged (int  controlId, int  value);
void selectionChanged (int  controlId, int  start, int  end);
void keyDown (int  key);
void keyUp (int  key);
void receiveFocus ();
void loseFocus ();
void mouseMove (int  dx, int  dy);
void mouseButtonDown (int  button);
void mouseButtonUp (int  button);
void mouseScroll (int  dx);
void repaint (int  wid, int  x, int  y, int  width, int  height);
void onDataReceived();
};
#endif
