#include <QApplication>
#include"gen.h"




#include<QMessageBox>
#include<QPushButton>
#include<QMainWindow>
#include<QHash>
#include<QMenu>
#include<QMenuBar>
#include<QTextEdit>
#include<QTextCursor>
#include<QGridLayout>

#include"action.h"

#include"widget.h"

#include"control.h"

#include"window.h"

#define S(x) x.toLocal8Bit().constData()

#include"accesswindow.h"
	 AccessWindow* aw;

class MyConnection : public GeneratedConnection {
  public:
	virtual ~MyConnection() { }
//////////////
QHash<int, Window*> windows;
QHash<int, Action*> actions;
QHash<int, QMenu*> menus;

QHash<int, Widget*> consoles;
QHash<int, Control*> controls;

virtual void clientNameChanged(int id, QString name) {
	aw->clientNameChange(id, name);

}

virtual void clientTerminated(int id) {
	aw->removeClient(id);
}


virtual void createConsole(int id) {
	Widget* w = new Widget();
	w->show();

	consoles[id] = w;

	printf("console: %d\n", id);
}




virtual void showWindow(int id) {
	QWidget* w = windows[id]->widget;
	if(!w) {
		printf("no widget\n");
		return;
	}
	w->show();
}

virtual void createControl(int id, int type, int parent) {
	Window* par = windows[parent];
	if(!par) {
		printf("orphan\n");
		return;
	}
	QWidget* p = par->controlSurface();

	if(!p) {
		printf("no parent\n");
		return;
	}
	
	Control* w = new Control(this, type, p, id);

	controls[id] = w;
}

virtual void setControlText(int id, QString text) {
	Control* ct = controls[id];
	if(!ct) return;
		ct->programedEdit = true;

	QTextEdit* t = qobject_cast<QTextEdit*>(ct->widget);
	if(t) {
		t->setPlainText(text);
		return;
	}

	QLineEdit* l = qobject_cast<QLineEdit*>(ct->widget);
	if(l) {
		l->setText(text);
		return;
	}

	QPushButton* p = qobject_cast<QPushButton*>(ct->widget);
	if(p) {
		p->setText(text);
	}
	QLabel* lab = qobject_cast<QLabel*>(ct->widget);
	if(lab) {
		lab->setText(text);
	}
}

virtual void appendControlText(int id, QString text) {
	Control* ct = controls[id];
	if(!ct) return;
		ct->programedEdit = true;

	QTextEdit* t = qobject_cast<QTextEdit*>(ct->widget);
	if(t) {
		t->setPlainText(t->toPlainText() + text);
			// maybe could be better
			QTextCursor c = t->textCursor();
			c.setPosition(t->toPlainText().length());
			t->setTextCursor(c);
		t->ensureCursorVisible();
		return;
	}
}

virtual void setControlGeometry(int id, int x, int y, int w, int h) {
	QWidget* c;
	Control* ct = controls[id];
	if(!ct){
		printf("lol %d\n", id);
		return;
	}
	c = ct->widget;

	if(!c){
		printf("wtf\n");
		return;
	}

	QWidget* p = c->parentWidget();


	if(!p){
		printf("fuck\n");
		return;
	}


	QGridLayout* l = qobject_cast<QGridLayout*>(p->layout());
	if(!l){
		printf("shit\n");
		return;
	}
	l->addWidget(c, y, x, h, w);
/*
	// Values from the controls
	int maxx = x + w;
	int maxy = y + h;

	// moving on...
	int parentw = c->parentWidget()->width();
	int parenth = c->parentWidget()->height();

	int pelsx = parentw / maxx;
	int pelsy = parenth / maxy;

	c->move(x * pelsx, y * pelsy);
	c->resize(w * pelsx, h * pelsy);

	printf("window: %d x %d\n", parentw, parenth);
	printf("%d x %d\n", pelsx, pelsy);
*/
}

virtual void createMainWindow (int id){

	Window* w = new Window(this, id, MainWindow, 0);

//	QPushButton* pb = new QPushButton("test", w);
//	pb->move(30,23);
//	pb->resize(100, 34);


	windows[id] = w;
}


virtual void newClient(int id) {
	emit newClientAvailable(id);
//	attachClient(id);
}

virtual void setWindowTitle (int id, QString  title){
	QWidget* w = windows[id]->widget;
	if(w)
	w->setWindowTitle(title);
}

virtual void closeWindow(int id) {
	QWidget* w = windows[id]->widget;
	if(w)
		delete w;
	delete windows[id];
	windows.remove(id);
}

virtual void messageBox (QString  title, QString  message){
	QMessageBox::information(0, title, message, 0);
}

virtual void createAction(int id) {
	Action* a = new Action(this, id);
	actions[id] = a;
}

virtual void createMenu(int id, QString title) {
	menus[id] = new QMenu(title);
}

virtual void addMenuItem(int menuId, int actionId) {
	menus[menuId]->addAction(actions[actionId]);
}

virtual void setActionText(int actionId, QString text) {
	actions[actionId]->setText(text);
}

virtual void addMenu(int wid, int mid) {
	QMainWindow* w = qobject_cast<QMainWindow*>(windows[wid]->widget);
	if(w)
		w->menuBar()->addMenu(menus[mid]);
	else
		printf("invalid window\n");
}



////////////////////////////
};









   int main(int argc, char *argv[])
    {
         QApplication app(argc, argv);
	 app.setQuitOnLastWindowClosed(false);
	 aw = new AccessWindow();

              MyConnection lol;

	 QObject::connect(&lol, SIGNAL(newClientAvailable(int)), aw, SLOT(newClient(int)));
	 QObject::connect(aw, SIGNAL(attachRequested(int)), &lol, SLOT(doAttach(int)));
	 QObject::connect(aw, SIGNAL(detachRequested(int)), &lol, SLOT(doDetach(int)));
	 QObject::connect(aw, SIGNAL(closing()), &app, SLOT(quit()));
	 aw->show();


        return QCoreApplication::exec();
    }
