#include"widget.h"

#include<QPainter>
#include<QKeyEvent>
#include<QFontMetrics>

Widget::Widget(QWidget* parent)
  	: QWidget(parent)
{

	setWindowTitle("ARSD MegaTerm");

	font.setFamily("Monospace");
	font.setPixelSize(16);
	font.setKerning(false);

	QFontMetrics fm(font);
	fonth = fm.height();
	fontw = fm.averageCharWidth();


	setStyleSheet("QWidget { background-color: black; }");

	setSizeIncrement(fontw, fonth);

	width = 80;
	height = 25;

	resize(width * fontw, height * fonth);

	txtbuffer.resize((width+1)*height);
	for(int x = 0; x < width+1; x++)
	for(int y = 0; y < height; y++)
		if(x == width)
			txtbuffer[y*(width+1) + x] = '\n';
		else
			txtbuffer[y*(width+1) + x] = (x == 0 ? '~' : ' ' );

	cursorY = 0;
	cursorX = 0;

	setFocusPolicy(Qt::StrongFocus);
}

void Widget::keyPressEvent(QKeyEvent* event){
	switch(event->key()){
		case Qt::Key_Left:
			if(cursorX)
				cursorX--;
		break;
		case Qt::Key_Right:
			if(cursorX < width-1)
				cursorX++;
		break;
		case Qt::Key_Up:
			if(cursorY)
				cursorY--;
		break;
		case Qt::Key_Down:
			if(cursorY < height-1)
				cursorY++;
		break;
		default:
			QWidget::keyPressEvent(event);
	}

	update();
}

void Widget::paintEvent(QPaintEvent* event){
	QPainter p(this);
	p.setFont(font);
	p.setPen(QColor(0, 255, 0));


	p.drawText(0, 0, width*fontw, height*fonth, Qt::AlignLeft | Qt::AlignTop | Qt::TextExpandTabs, txtbuffer);

	p.drawRect(cursorX * fontw, cursorY * fonth, fontw, fonth);

}
