#ifndef WINDOW_H
#define WINDOW_H

#include<QWidget>
#include<QMainWindow>
#include<QCloseEvent>

#include"gen.h"

// private
enum WindowTypes {
	MainWindow,
	Dialog,
	Frame,
	Page,
	Popup
};


class Window {
  public:
	Window(GeneratedConnection* c, int i, int t, Window* parent);

	QWidget* controlSurface();


	GeneratedConnection* client;
	int id;
	int type;
	/* Main window
	   Dialog
	   Frame
	   Page
	   Pop up
	   Dock?
	*/
	QWidget* widget;
};

class MyMainWindow : public QMainWindow {
	Q_OBJECT
  public:
	MyMainWindow(Window* w, QWidget* parent = NULL);
	void closeEvent(QCloseEvent *event);

	Window* owner;
};


#endif
