import base;

class PushButton : Control {
	this(string text, Window p, void delegate() onPressa, Display d = null) {
		super(p, d);
		display.createControl(id, ControlTypes.PushButton, p.id);
		display.setControlText(id, text);
		onPress = onPressa;
	}
}

class ListBox : Control {
	this(Window p, Display d = null) {
		super(p, d);
		display.createControl(id, ControlTypes.ListBox, p.id);
	}
}

class RichTextEdit : Control {
	this(Window p, Display d = null) {
		super(p, d);
		display.createControl(id, ControlTypes.RichTextEdit, p.id);
	}


	void appendText(string t) {
		text ~= t;
		display.appendControlText(id, t);
	}

	void setText(string t) {
		text = t;
		display.setControlText(id, t);
	}

  private:
	static RichTextEdit[int] all;
}

class Label : Control {
	this(string text, Window p, Display d = null) {
		super(p, d);
		display.createControl(id, ControlTypes.Label, p.id);
		display.setControlText(id, text);
	}
}

class LineEdit : Control {
	this(Window p, Display d = null) {
		super(p, d);
		display.createControl(id, ControlTypes.LineEdit, p.id);
	}

	void appendText(string t) {
		text ~= t;
		display.appendControlText(id, t);
	}

	void setText(string t) {
		text = t;
		display.setControlText(id, t);
	}

  private:
	static LineEdit[int] all;
}


enum ControlTypes {
	PushButton,
	Label,
	RichTextEdit,
	TextEdit,
	LineEdit,
	HTMLViewer,
	CheckBox,
	RadioButton,
	DropDownList,
	ComboBox,
	SpinBox,
	ScrollBar,
	Slider,
	ProgressBar,
	ListBox,
	ToolButton,
	Group
}

