import base;

class Console {
	this(Display d = null) {
		init(d);
		display.createConsole(id);
	}

	mixin ServerResource!(Console);
}

class MainWindow : Window {
	this(Display d = null) {
		init(d);
		display.createMainWindow(id);

		windowsOpen++;
	}

	void addMenu(Menu m) {
		display.addMenu(id, m.id);
	}

	string title() {
		return windowTitle;
	}

	void title(string t) {
		windowTitle = t;
		display.setWindowTitle(id, t);
	}

	string statusBar() {
		return statusBarText;
	}

	void statusBar(string t) {
		statusBarText = t;
		display.setStatusBarText(id, t);
	}

  private:
	string windowTitle;
	string statusBarText;

	static MainWindow[int] all;
	static int windowsOpen;
}



