/*
string[] types = [
	"int", "uint",
	"char", 
	"byte", "sbyte",
	"word", "sword",
	"dword", "sdword",
	"string",
	"void"
];
*/
/+
// For simplicity in the first version

string[] types = [
	"int", "char",
	"void"
];

string[] keywords = [
	"enum", "struct", "bitfield" // typedef
];

/*
	Type:
		type [name]
		OR
		keyword [name] { Type;... }
		ALSO
		Type[] -- array
	Function:
		Type name ( Type[, Type]... );


	File:
		keyword name { Type... }
		Function


	You can group stuff with colons.

	-------------------

	In general:

		return name(args...);

		Translates to:

		client:
		void name(args..., void delegate(return) response);

		server:
		void name(args..., out return...);

		Low level implementation:
		Every message has a message size
		If it has a non-void return value, it also has a message ID
*/

string identifyerRegexp = "[A-Za-z][A-Za-z_0-9]*";


class Type {

}

class Array : Type {
	Type base;
}

struct Function {
	Type[] returnValues;
	Type[] arguments;

	string name;
}

+/

string readToken(string input, inout int where) {

	if(where >= input.length)
		return null;
    skipMore:
	// Skip leading whitespace...
	while(input[where] == ' ' || input[where] == '\n' || input[where] == '\t') {
		where++;
		if(where >= input.length)
			return null;
	}

	bool skipped = false;

	// Skip leading comments too...
	if(input[where] == '/') {
		if(input[where+1] == '/') {
			// C99 comment
			while(where < input.length && input[where] != '\n')
				where++;
			where++;

			skipped = true;
		}
		if(input[where+1] == '*') {
			// C comment
			where += 2;
			while((where < input.length) && !(input[where] == '*' && input[where+1] == '/'))
				where ++;

			where += 2;

			skipped = true;
		}

	}

	if(skipped)
		goto skipMore;




	int start = where;

	bool lol() { return (
		(input[where] >= 'a' && input[where] <= 'z')
		  || (input[where] >= 'A' && input[where] <= 'Z')
		  || (input[where] >= '0' && input[where] <= '9')
		  ||  input[where] == '_' || input[where] == '['
		  ||  input[where] == ']') ; }

	if(!lol()) {
		where++;
	} else while( lol() ) {
	    	where++;
		if(where >= input.length)
			break;
	}

	return input[start..where];
}



struct Var {
	string type;
	string name;
}

struct Function {
	string label;
	string name;
	Var[] returnValues;
	Var[] args;

	int number;
}


import std.stdio;
import std.file;

int main(string[] args) {


	string data = cast(string) read(args[1]);
	int where = 0;

	string[] tokens;

	auto token = readToken(data, where);
	while(token && where < data.length) {
		tokens ~= token;
		token = readToken(data, where);
	}



	// reading

	// if peek is colon, we are dealing with a label
	// if current is typedef, we are dealing with a newly defined type
	// otherwise we are looking at a function declaration


	int current = 0;

	string peek(int howMuch = 1) {
		return tokens[current + howMuch];
	}

	string cur() {
		return tokens[current];
	}



	Var readVar() {
		Var v;
		v.type = cur();
		current++;

		if(v.type != "void" && peek() != "(") {
			v.name = cur();
			current++;
		}
		return v;
	}


	string currentLabel;

	Function[] functions;
	int num = 0;

	while(current < tokens.length) {
		if(cur() == "typedef") {
			// defining a type
			// FIXME
			throw new Exception("not yet implemented");
		} else if (peek() == ":") {
			// we're on a label
			currentLabel = cur();
			current += 2; // skip name and colon
		} else {
			// parse the function

			Function f;

			f.label = currentLabel;

		    moreTypes:
		    	Var v = readVar();
			if(v.type != "void")
				f.returnValues ~= v;
			if(cur() == ",") {
				current++;
				goto moreTypes;
			}

			f.name = cur();
			current++;

			assert(cur() == "(", "!" ~ cur() ~ "!");
			current++;

			if(cur() == ")")
				goto done;

		    moreTypes2:
		    	v = readVar();
			if(v.type != "void")
				f.args ~= v;

			if(cur() == ",") {
				current++;
				goto moreTypes2;
			}

		    done:
			assert(cur() == ")");
			current++;
			assert(cur() == ";");
			current++;

			/*
				type [name]
				[, type [name]]...
				funcName
				(
				[type [name]]
				[, type [name]]...
				)
				;
			*/

			f.number = num++;

			functions ~= f;
		}
	}




/* ************************************************** */
/* ************************************************** */
/* ************************************************** */
/* ************************************************** */
/*	Code generation section begins here           */
/* ************************************************** */
/* ************************************************** */
/* ************************************************** */
/* ************************************************** */



	string implements = args[2];

	//////
writef(`
import std.stdio;
import arsd.netman;
import num;

num n;


class GeneratedConnection : Connection {
public:
/*
void onConnect() {
	sendMessage(23, "hello!");
}
*/

`);

	/////


	// First, generate the interesting stuff
	foreach(f; functions) {
		if(implements == f.label) {
			generateReceiveRequestCode(f);
		} else {
			generateSendRequestCode(f);
		}
	}


	// Then the ugly switch code


	writefln("override void onDataReceived() {");
	writef(q{
		const(byte)[] buffer = read();
		int func;
		int where;
		byte* lol;
		int rid;

	});

	writefln("while(where < buffer.length){");
	writef(q{

		int te = where;

		while(te < buffer.length) {
			if(!(buffer[te] & 0b_1000_0000))
				goto gotit;
			te++;
		}
		return; // don't have the complete length field yet; should never happen

		gotit:
			n.fromByteArray(buffer, where); // this is the length of the rest of the message

			int length = n.toInt();

			if((length + where) > buffer.length)
				return; // we don't have the whole message yet, wait for more

			n.fromByteArray(buffer, where);
			func = n.toInt();


	});
	writefln("switch(func) {");

	foreach(f; functions) {
		if(implements == f.label) {
			generateReceiveRequestCaseCode(f);
		} else {
			generateReceiveResponseCaseCode(f);
		}
	}

	writefln("}"); // for the switch

	writefln("changeReadPosition(where); }"); // end of the loop


	writefln("resetRead();}"); // for the data received function

	/////
	writefln("}"); // for the class

	return 0;
}

void writeArgs(string prefix, Var[] wat) {
	bool outputted;
	foreach(v; wat) {
		writef("%s%s%s %s", outputted ? ", " : "", prefix, v.type, v.name is null ? "val" : v.name);
		outputted = true;
	}
}


// You are the server who just got the request
void generateReceiveRequestCaseCode(Function f) {



writef(q{
	  case %d: // %s
	  	// size is set up before the switch (size already has the header removed)

	  	// The expected arguments are the args of the function
		// declare them and extract them from the byte stream
}, f.number, f.name);

	if(f.returnValues.length) {
writef(q{
		n.fromByteArray(buffer, where);
		rid = n.toInt();
});
	}

	foreach(v; f.args) {
		writefln("\t\t%s %s;", v.type, v.name ? v.name : "val");
	}

		getArgsFromByteStream(f.args);

writef("
		// ensure the size extracted matches the size we expected; otherwise it is a protocol error
		// FIXME

		// call the virtual function to handle the request
");


	// Declaring the return value variables
	foreach(v; f.returnValues) {
		writefln("\t\t%s %s;", v.type, v.name ? v.name : "val");
	}

	// Outputting the function call:

	writef("\t\t%s(", f.name);

	bool outputted = false;
	foreach(arg; f.args) {
		writef("%s%s", outputted ? ", ":"", arg.name ? arg.name : "val");
		outputted = true;
	}

	foreach(arg; f.returnValues) {
		writef("%s%s", outputted ? ", " : "", arg.name ? arg.name : "val");
		outputted = true;
	}


	writef(");");


	if(f.returnValues.length) {
	// now the return values from that virtual function need to be sent to the output buffer
		makeOutputBuffer(f, "2");

		putArgsToByteStream(f.returnValues, "2");

		completeOutputBuffer("2");
	}

	// And finally, done!
writef("
	  break;
");



}

// You just got the response from the server; call the delegate
void generateReceiveResponseCaseCode(Function f) {
	if(f.returnValues.length == 0)
		return; // if it has no return values, we should never receive such a message

writef(q{
	  case %d: // %s
	  	// size is set up before the switch (size already has the header removed)

	  	// The expected arguments are the return value of the function
		// declare them and extract them from the byte stream
}, f.number, f.name);


	if(f.returnValues.length) {
writef(q{
	n.fromByteArray(buffer, where);
	rid = n.toInt();
});
	}

	foreach(v; f.returnValues) {
		writefln("\t\t%s %s;", v.type, v.name ? v.name : "val");
	}

		getArgsFromByteStream(f.returnValues);

writef("
		// ensure the size extracted matches the size we expected; otherwise it is a protocol error
		// FIXME

		// call the delegate
		responseDelegates%d[rid](", f.number);

	bool outputted = false;
	foreach(v; f.returnValues) {
		writef("%s%s", outputted ? ", " : "", v.name ? v.name : "val");
		outputted = true;
	}
		
writef(");
	  break;
");

}


// the stub for implementation of this
// Just prints that we received the message by default (for debugging)
void generateReceiveRequestCode(Function f) {
	writefln("// /////////////////////////////");
	writefln("// ////////OVERRIDE ME//////////");
	writefln("// /////////////////////////////");
	writef("void %s (", f.name);

	writeArgs("", f.args);

	if(f.returnValues.length) {
		writef("%s", f.args.length ? ", " : "");
		writeArgs("out ", f.returnValues);
	}

	writefln("){");

writef(`	writefln("Received: %s(`, f.name);
	bool outputted = false;
	foreach(v; f.args) {
		writef(`%s%s`, outputted ? ", ":"", "%s");
		outputted = true;
	}

	writef(`)"`);
	foreach(v; f.args)
		writef(", %s", v.name);

writef(");\n");

	writefln("}");

}

// this is the code that sends the request
void generateSendRequestCode(Function f) {

	// Declare the array of response storage if needed
	if(f.returnValues.length) {
		writef("void delegate (");
		writeArgs("", f.returnValues);
		writefln(") %s%d[int];", "responseDelegates", f.number);
	}

	// And the function itself

	writef("void %s (", f.name);

	writeArgs("", f.args);

	if(f.returnValues.length) {
		writef("%svoid delegate (", f.args.length ? ", " : "");
		writeArgs("", f.returnValues);
		writef(") handle");
	}

	writef("){");

if(f.returnValues.length)
writef(q{
	static byte rid;
});

	makeOutputBuffer(f);

if(f.returnValues.length)
writef(q{
	// Store the delegate we were given with the function id and request id so we can call it later.
	responseDelegates%d[rid] = handle;

	rid++;
}, f.number);

// and now the function arguments
if(f.args.length)
	writefln("\n\t// Function arguments");


	putArgsToByteStream(f.args);


// And finally wrap it up - copy our buffer to the actual netout buffer and prepend the size
	completeOutputBuffer();


	writefln("}\n");
}



void makeOutputBuffer(Function f, string postlol = "") {
writef(q{
	byte[1024] buffer%s;
	int where%s = 4; // leave some room for the size header

	num n;
	n.fromInt(%d); // function number
	n.toByteArray(buffer%s, where%s);
}, postlol, postlol, f.number, postlol, postlol);

if(postlol == "")
	writefln("byte* lol;"); // hackish

// if return values, output the request id
if(f.returnValues.length)
writef(q{
	n.fromInt(rid);
	n.toByteArray(buffer%s, where%s);
}, postlol, postlol);
}

void completeOutputBuffer(string postlol = "") {
writef(q{
	// Prepend the size of the message
	n.fromInt(where%s - 4);
	int nlol = 4 - n.used;
	int ncpy = nlol;
	n.toByteArray(buffer%s, nlol);

	// write the used part of the buffer to the output device
	write(buffer%s[ncpy..where%s]);
}, postlol, postlol, postlol, postlol);

}



void putArgsToByteStream(Var[] args, string postlol=""){
	foreach(arg; args) {
		switch(arg.type) { // FIXME: add more types
		  case "string":
writef(q{
	n.fromInt(%s.length);
	n.toByteArray(buffer%s, where%s);

	lol = cast(byte*) %s.ptr;

	for(int a = 0; a < %s.length; a++){
		buffer%s[where%s++] = *lol;
		lol++;
	}
}, arg.name ? arg.name : "val", 
	postlol, postlol,
arg.name ? arg.name : "val",
arg.name ? arg.name : "val",
	postlol, postlol
);
		  break;

		  case "byte[]":
writef(q{
	n.fromInt(%s.length);
	n.toByteArray(buffer%s, where%s);

	lol = cast(byte*) %s.ptr;

	for(int a = 0; a < %s.length; a++){
		buffer%s[where%s++] = *lol;
		lol++;
	}
}, arg.name ? arg.name : "val", 
	postlol, postlol,
arg.name ? arg.name : "val",
arg.name ? arg.name : "val",
	postlol, postlol
);
		  break;


		  case "int":
writef(q{
	n.fromInt(%s);
	n.toByteArray(buffer%s, where%s);
}, arg.name ? arg.name : "val", postlol, postlol);
		  break;
		}
	}
}

void getArgsFromByteStream(Var[] args, string postlol = ""){
	foreach(arg; args) {
		switch(arg.type) { // FIXME: add more types
		  case "string":
writef(q{
	n.fromByteArray(buffer%s, where%s);
	%s.length = n.toInt();

	lol = cast(byte*) %s.ptr;

	for(int a = 0; a < %s.length; a++) {
		*lol = buffer%s[where%s++];
		lol++;
	}
}, postlol, postlol,

arg.name ? arg.name : "val",

arg.name ? arg.name : "val", arg.name ? arg.name : "val",
postlol, postlol
);
		  break;

		  case "byte[]":
writef(q{
	n.fromByteArray(buffer%s, where%s);
	%s.length = n.toInt();

	lol = cast(byte*) %s.ptr;

	for(int a = 0; a < %s.length; a++) {
		*lol = buffer%s[where%s++];
		lol++;
	}
}, postlol, postlol,

arg.name ? arg.name : "val",

arg.name ? arg.name : "val", arg.name ? arg.name : "val",
postlol, postlol
);
		  break;



		  case "int":
writef(q{
	n.fromByteArray(buffer%s, where%s);
	%s = n.toInt();
},postlol, postlol, arg.name ? arg.name : "val");
		  break;
		}
	}
}

