string readToken(string input, inout int where) {

	if(where >= input.length)
		return null;
    skipMore:
	// Skip leading whitespace...
	while(input[where] == ' ' || input[where] == '\n' || input[where] == '\t') {
		where++;
		if(where >= input.length)
			return null;
	}

	bool skipped = false;

	// Skip leading comments too...
	if(input[where] == '/') {
		if(input[where+1] == '/') {
			// C99 comment
			while(where < input.length && input[where] != '\n')
				where++;
			where++;

			skipped = true;
		}
		if(input[where+1] == '*') {
			// C comment
			where += 2;
			while((where < input.length) && !(input[where] == '*' && input[where+1] == '/'))
				where ++;

			where += 2;

			skipped = true;
		}

	}

	if(skipped)
		goto skipMore;




	int start = where;

	bool lol() { return (
		(input[where] >= 'a' && input[where] <= 'z')
		  || (input[where] >= 'A' && input[where] <= 'Z')
		  || (input[where] >= '0' && input[where] <= '9')
		  ||  input[where] == '_' || input[where] == '['
		  ||  input[where] == ']') ; }

	if(!lol()) {
		where++;
	} else while( lol() ) {
	    	where++;
		if(where >= input.length)
			break;
	}

	return input[start..where];
}



struct Var {
	string type;
	string name;
}

struct Function {
	string label;
	string name;
	Var[] returnValues;
	Var[] args;

	int number;
}


import std.stdio;
import std.file;

bool header;

int main(string[] args) {


	string data = cast(string) read(args[1]);
	int where = 0;

	string[] tokens;

	auto token = readToken(data, where);
	while(token && where < data.length) {
		tokens ~= token;
		token = readToken(data, where);
	}



	// reading

	// if peek is colon, we are dealing with a label
	// if current is typedef, we are dealing with a newly defined type
	// otherwise we are looking at a function declaration


	int current = 0;

	string peek(int howMuch = 1) {
		return tokens[current + howMuch];
	}

	string cur() {
		return tokens[current];
	}



	Var readVar() {
		Var v;
		v.type = cur();
		current++;

		if(v.type != "void" && peek() != "(") {
			v.name = cur();
			current++;
		}

		if(v.type == "string")
			v.type = "QString";
		if(v.type == "byte[]")
			v.type = "QByteArray";
		return v;
	}


	string currentLabel;

	Function[] functions;
	int num = 0;

	while(current < tokens.length) {
		if(cur() == "typedef") {
			// defining a type
			// FIXME
			throw new Exception("not yet implemented");
		} else if (peek() == ":") {
			// we're on a label
			currentLabel = cur();
			current += 2; // skip name and colon
		} else {
			// parse the function

			Function f;

			f.label = currentLabel;

		    moreTypes:
		    	Var v = readVar();
			if(v.type != "void")
				f.returnValues ~= v;
			if(cur() == ",") {
				current++;
				goto moreTypes;
			}

			f.name = cur();
			current++;

			assert(cur() == "(", cur());
			current++;

			if(cur() == ")")
				goto done;

		    moreTypes2:
		    	v = readVar();
			if(v.type != "void")
				f.args ~= v;

			if(cur() == ",") {
				current++;
				goto moreTypes2;
			}

		    done:
			assert(cur() == ")");
			current++;
			assert(cur() == ";");
			current++;

			/*
				type [name]
				[, type [name]]...
				funcName
				(
				[type [name]]
				[, type [name]]...
				)
				;
			*/

			f.number = num++;

			functions ~= f;
		}
	}




/* ************************************************** */
/* ************************************************** */
/* ************************************************** */
/* ************************************************** */
/*	Code generation section begins here           */
/* ************************************************** */
/* ************************************************** */
/* ************************************************** */
/* ************************************************** */



	string implements = args[2];

	if(args.length > 3 && args[3] == "header")
		header = true;

	//////

if(header)
writef(`
#ifndef GEN_H
#define GEN_H
#include"num.h"

#include<QString>
#include<QByteArray>

#include"client.h"

class GeneratedConnection : public Client{
public:


`);
else
writefln(`#include"gen.h"
QByteArray qba;
num n;

#define cast /**/
`);

	/////


	// First, generate the interesting stuff
	foreach(f; functions) {
		if(implements == f.label) {
			generateReceiveRequestCode(f);
		} else {
			generateSendRequestCode(f);
		}
	}


	// Then the ugly switch code

	if(header)
	writefln("void onDataReceived();");
	else {
	writefln("void GeneratedConnection::onDataReceived() {");
	writef(q{
		QByteArray& buffer = read();
		int func;
		int where = 0;
		byte* lol;
		int rid;

	});

	writefln("while(where < buffer.length()){");
	writef(q{

		int te = where;

		while(te < buffer.length()) {
			if(!(buffer[te] & 0x80))
				goto gotit;
			te++;
		}
		return; // don't have the complete length field yet; should never happen

		gotit:
			n.fromByteArray(buffer, where); // this is the length of the rest of the message

			int length = n.toInt();

			if((length + where) > buffer.length())
				return; // we don't have the whole message yet, wait for more

			n.fromByteArray(buffer, where);
			func = n.toInt();


	});
	writefln("switch(func) {");

	foreach(f; functions) {
		if(implements == f.label) {
			generateReceiveRequestCaseCode(f);
		} else {
			generateReceiveResponseCaseCode(f);
		}
	}

	writefln("}"); // for the switch

	writefln("changeReadPosition(where); }"); // end of the loop


	writefln("resetRead();}"); // for the data received function
	} // if !header
	/////
	if(header)
	writefln("};\n#endif"); // for the class

	return 0;
}

void writeArgs(string prefix, Var[] wat) {
	bool outputted;
	foreach(v; wat) {
		writef("%s%s %s %s", outputted ? ", " : "", v.type, prefix, v.name is null ? "val" : v.name);
		outputted = true;
	}
}


// You are the server who just got the request
void generateReceiveRequestCaseCode(Function f) {



writef(`
	  case %d: {// %s
	  	// size is set up before the switch (size already has the header removed)

	  	// The expected arguments are the args of the function
		// declare them and extract them from the byte stream
`, f.number, f.name);

	if(f.returnValues.length) {
writef(q{
		n.fromByteArray(buffer, where);
		rid = n.toInt();
});
	}

	foreach(v; f.args) {
		writefln("\t\t%s %s;", v.type, v.name ? v.name : "val");
	}

		getArgsFromByteStream(f.args);


	// Declaring the return value variables
	foreach(v; f.returnValues) {
		writefln("\t\t%s %s;", v.type, v.name ? v.name : "val");
	}

	// Outputting the function call:

	writef("\t\t%s(", f.name);

	bool outputted = false;
	foreach(arg; f.args) {
		writef("%s%s", outputted ? ", ":"", arg.name ? arg.name : "val");
		outputted = true;
	}

	foreach(arg; f.returnValues) {
		writef("%s%s", outputted ? ", " : "", arg.name ? arg.name : "val");
		outputted = true;
	}


	writef(");");


	if(f.returnValues.length) {
	// now the return values from that virtual function need to be sent to the output buffer
		makeOutputBuffer(f, "2");

		putArgsToByteStream(f.returnValues, "2");

		completeOutputBuffer("2");
	}

	// And finally, done!
writef("
	  }break;
");



}

// You just got the response from the server; call the delegate
void generateReceiveResponseCaseCode(Function f) {
	if(f.returnValues.length == 0)
		return; // if it has no return values, we should never receive such a message

writef(`
	  case %d: { // %s
	  	// size is set up before the switch (size already has the header removed)

	  	// The expected arguments are the return value of the function
		// declare them and extract them from the byte stream
`, f.number, f.name);


	if(f.returnValues.length) {
writef(q{
	n.fromByteArray(buffer, where);
	rid = n.toInt();
});
	}

	foreach(v; f.returnValues) {
		writefln("\t\t%s %s;", v.type, v.name ? v.name : "val");
	}

		getArgsFromByteStream(f.returnValues);

writef("
		// ensure the size extracted matches the size we expected; otherwise it is a protocol error
		// FIXME

		// call the delegate
		responseDelegates%d[rid](", f.number);

	bool outputted = false;
	foreach(v; f.returnValues) {
		writef("%s%s", outputted ? ", " : "", v.name ? v.name : "val");
		outputted = true;
	}
		
writef(");
	  } break;
");

}


// the stub for implementation of this
// Just prints that we received the message by default (for debugging)
void generateReceiveRequestCode(Function f) {
	if(header)
	writef("virtual void %s (", f.name);
	else
	writef("void GeneratedConnection::%s (", f.name);

	writeArgs("", f.args);

	if(f.returnValues.length) {
		writef("%s", f.args.length ? ", " : "");
		writeArgs(" & ", f.returnValues);
	}

	writef(")");
	if(header)
		writefln(";");
	else {
	writefln("\n{");
		writefln("printf(\"FIXME: function %s not implemented\\n\");", f.name);
	writefln("}");
	}

}

// this is the code that sends the request
void generateSendRequestCode(Function f) {

	// Declare the array of response storage if needed
	if(f.returnValues.length) {
		writef("typedef void (*presponseDelegates%d) (", f.number);
		writeArgs("", f.returnValues);
		writefln(");");
		writefln("presponseDelegates%d responseDelegates%d[256];", f.number, f.number);

		//writef("virtual ");
	}

	// And the function itself

	if(header)
	writef("void %s (", f.name);
	else
	writef("void GeneratedConnection::%s (", f.name);

	writeArgs("", f.args);

	if(f.returnValues.length) {
		writef("%svoid (*handle) (", f.args.length ? ", " : "");
		writeArgs("", f.returnValues);
		writef(")");
	}

	if(header)
		writef(");\n");
	else {

	writef("){");

if(f.returnValues.length)
writef(q{
	static byte rid;
});

	makeOutputBuffer(f);

if(f.returnValues.length)
writef(q{
	// Store the delegate we were given with the function id and request id so we can call it later.
	responseDelegates%d[rid] = handle;

	rid++;
}, f.number);

// and now the function arguments
if(f.args.length)
	writefln("\n\t// Function arguments");


	putArgsToByteStream(f.args);


// And finally wrap it up - copy our buffer to the actual netout buffer and prepend the size
	completeOutputBuffer();


	writefln("}\n");
	}
}



void makeOutputBuffer(Function f, string postlol = "") {
writef(q{
	byte buffer%s[1024];
	int where%s = 4; // leave some room for the size header

	num n;
	n.fromInt(%d); // function number
	n.toByteArray(buffer%s, where%s);
}, postlol, postlol, f.number, postlol, postlol);

if(postlol == "")
	writefln("byte* lol;"); // hackish

// if return values, output the request id
if(f.returnValues.length)
writef(q{
	n.fromInt(rid);
	n.toByteArray(buffer%s, where%s);
}, postlol, postlol);
}

void completeOutputBuffer(string postlol = "") {
writef(q{
	// Prepend the size of the message
	n.fromInt(where%s - 4);
	int nlol = 4 - n.used;
	int ncpy = nlol;
	n.toByteArray(buffer%s, nlol);

	// write the used part of the buffer to the output device
	write(buffer%s, ncpy, where%s);
}, postlol, postlol, postlol, postlol);

}



void putArgsToByteStream(Var[] args, string postlol=""){
	foreach(arg; args) {
		switch(arg.type) { // FIXME: add more types
		  case "QString":
writef(q{

	qba = %s.toUtf8();
	n.fromInt(qba.length());
	n.toByteArray(buffer%s, where%s);

	lol = cast(byte*) qba.data();

	for(int a = 0; a < qba.length(); a++){
		buffer%s[where%s++] = *lol;
		lol++;
	}
}, arg.name ? arg.name : "val", 
	postlol, postlol,
	postlol, postlol
);
		  break;
		  case "QByteArray":
writef(q{

	qba = %s;
	n.fromInt(qba.length());
	n.toByteArray(buffer%s, where%s);

	lol = cast(byte*) qba.data();

	for(int a = 0; a < qba.length(); a++){
		buffer%s[where%s++] = *lol;
		lol++;
	}
}, arg.name ? arg.name : "val", 
	postlol, postlol,
	postlol, postlol
);

		  break;
		  case "int":
writef(q{
	n.fromInt(%s);
	n.toByteArray(buffer%s, where%s);
}, arg.name ? arg.name : "val", postlol, postlol);
		  break;
		}
	}
}

void getArgsFromByteStream(Var[] args, string postlol = ""){
	foreach(arg; args) {
		switch(arg.type) { // FIXME: add more types
		  case "QString":
writef(q{
	n.fromByteArray(buffer%s, where%s);
	qba.resize(n.toInt());

	lol = cast(byte*) qba.data();

	for(int a = 0; a < qba.length(); a++) {
		*lol = buffer%s[where%s++];
		lol++;
	}

	%s = %s.fromUtf8(qba, qba.length());
}, postlol, postlol,

postlol, postlol,
arg.name ? arg.name : "val",
arg.name ? arg.name : "val"
);
		  break;
		  case "QByteArray":
writef(q{
	n.fromByteArray(buffer%s, where%s);
	qba.resize(n.toInt());

	lol = cast(byte*) qba.data();

	for(int a = 0; a < qba.length(); a++) {
		*lol = buffer%s[where%s++];
		lol++;
	}

	%s = qba;
}, postlol, postlol,

postlol, postlol,
arg.name ? arg.name : "val"
);
		  break;
		  case "int":
writef(q{
	n.fromByteArray(buffer%s, where%s);
	%s = n.toInt();
},postlol, postlol, arg.name ? arg.name : "val");
		  break;
		}
	}
}

