enum MAX = 8;
struct num {
	/// Where should be pointing at the beginning of it. When we're done, we'll be pointing right after it.
	void fromByteArray(const(byte)[] a, inout int where) {
		int w;
		for(w = 0; w < MAX; w++){
			byte b = a[where];
			where++;
			value[w] = b;
			if(!(b & 0b_1000_0000))
				break;
		}

		used = w;
	}

	void toByteArray(byte[] a, inout int where) {
		for(int c = 0; c < used; c++)
			a[where++] = value[c];
	}

	int toInt() {
		int sum = 0;

		for(int w = 0; w < MAX /* used */; w++) {
			int v = value[w] & 0b_0111_1111;

			v <<= (7 * w);
			sum |= v;

			if(!(value[w] & 0b_1000_0000))
				break;
		}

		return sum;
	}

	void fromInt(int n) {
		int val = n;
		int w = 0;

		bool more = true;
		while(more) {
			byte v = val & 0b_0111_1111;
			val >>>= 7;
			more = (val != 0);

			if(more)
				v |= 0b_1000_0000;

			value[w] = v;
			w++;
		}

		used = w;
	}


	int used;
	byte[MAX] value;
}

