import arsd.netman;
import std.stdio;

import generated;



int[string] users;

class IMConnection : GeneratedConnection {
	void tryAuthenticate(string user, string pass) {
		assert(auth == -1);
		if(auto uidp = user in users) {
			int uid = *uidp;

			if(auto c = uid in authenticatedConnections) {
				// the user is already connected; just disconnect for now
				disconnect();
			} else {
				authenticationChange(uid);
				auth = uid;

				authenticatedConnections[auth] = this;
			}
		} else {
			disconnect();
		}
	}

	override void onConnect() {
		getAuthenticationData(&tryAuthenticate);
	}

	override void onDisconnect() {
		if(auth in authenticatedConnections)
			authenticatedConnections.remove(auth);
	}

	override void sendMessage(int id, string msg) {
		if(auto c = id in authenticatedConnections) {
			(*c).postMessage(auth, msg);
		}
	}

	int auth = -1;
}


IMConnection[int] authenticatedConnections;


void main() {
	users = ["test" : 1, "user" : 2, "lol" : 3];
	MyMan netman = new MyMan;

	netman.listen(8080);
	while( netman.proceed() ) { }
}


class MyMan : NetworkManager {
	override Connection allocConnection(int port) {
		return new IMConnection();
	}
}

